clearvars;
U = [1 0.1]';
N = 3;
dt = 0.1;

MotionNoise.sOmega = 0.01;
MotionNoise.sV = 0.03;

MeasurementNoise.sAngle = 0.6;
MeasurementNoise.sRange = 2;

robotPos = [0 0 0.2]';
features = [3 3; -2 2; 5 1]';
relativePos = features - repmat(robotPos(1:2,:),1,N);
Z(1,:) = sqrt(sum(relativePos.^2,1));
Z(2,:) = atan2(relativePos(2,:), relativePos(1,:)) - robotPos(3);
Z(3,:) = 1:3;


Particules(1).w = 0.3;
Particules(1).X = robotPos;  %[0.1 0.1 0]';

Particules(2).w = 0.7;
Particules(2).X = robotPos; %[-0.1 -0.1 0.1]';

for (iParticules = 1:2)
    for iLandmark = 1:N
        Particules(iParticules).LandmarkMu{iLandmark} = features(:,iLandmark) + 0.3*randn(2,1);
        Particules(iParticules).LandmarkSigma{iLandmark} = eye(2)*10;
    end
end



clf;
plot(features(1,:),features(2,:),'bx');
hold on;
plot(robotPos(1), robotPos(2), 'bo');
line([robotPos(1) robotPos(1)+0.5*cos(robotPos(3))], [robotPos(2) robotPos(2)+0.5*sin(robotPos(3))], 'color', 'b');
for index=1:N
    text(features(1,index)+0.1,features(2,index)+0.1,sprintf('%d',index));
end
axis equal
% for now, no noise


for iMove = 1:10
    Particules = FastSlamUpdate(Particules, [0 0]', Z, MotionNoise, MeasurementNoise, dt);
    figure(1); 
    plot(features(1,:),features(2,:),'bx');
    hold on;
    plot(robotPos(1), robotPos(2), 'bo');
    line([robotPos(1) robotPos(1)+0.5*cos(robotPos(3))], [robotPos(2) robotPos(2)+0.5*sin(robotPos(3))], 'color', 'b');
    plotParticulesState(Particules(1),1,'x');
    hold on;
end





